﻿using UnityEngine;
using System.Collections;

public class NoticeLine : MonoBehaviour
{
		Color y1 = new Color (1, 1, 0, .75f);
		Color y2 = new Color (1, 1, 0, .05f);

		Color g1 = new Color (.25f, .25f, .25f, .75f);
		Color g2 = new Color (.25f, .25f, .25f, .05f);

		Color b = new Color (0, 0, 0, 0);


		Color m1, m2;
		public int Resolution = 50;
		public float Power = .5f;
		public float Freq = .5f;
		public float Speed = -7;
		public Transform StatusLoc;
		public Transform AvatarLoc;


		float beginW, endW;
		bool vertical = false;

		LineRenderer lineRenderer;

		void Start ()
		{
				lineRenderer = gameObject.AddComponent<LineRenderer> ();
		
				lineRenderer.material = new Material (Shader.Find ("Particles/Additive"));
		
				lineRenderer.SetVertexCount (Resolution);
				SetColors (g1, g2);
			
		
		}
		void Update ()
		{

				int i = 0;
		
				while (i < Resolution) {
						if (AvatarLoc != null) {
								Vector3 pos = Vector3.Lerp (StatusLoc.position, AvatarLoc.position, (float)i / Resolution);

								Vector3 FinalPos = pos + new Vector3 (0, Mathf.Sin (i * Freq + Time.time * Speed) * Power, 0);

								if (!vertical) {
										Power = .05f;
										FinalPos = pos + new Vector3 (Mathf.Sin (i * Freq + Time.time * Speed) * Power * (i + .0001f / Resolution), 0, 0);
								}
			
								lineRenderer.SetPosition (i, FinalPos);
								i++;
						}

						lineRenderer.SetWidth (beginW, endW);
						lineRenderer.SetColors (m1, m2);
				}
		}
	
		public void SetWiggle (float amt)
		{
				if (amt > 1) {
						amt = 1;
				} else if (amt < 0) {
						amt = 0;
				}		

				Power = Mathf.Lerp (0, .1f, amt);
				Freq = Mathf.Lerp (0, 1, amt);
				Speed = Mathf.Lerp (0, 10, amt);
		}


		public void SetLine (Transform startLoc, Transform endLoc, int _res, bool _verttical)
		{
				StatusLoc = startLoc;
				AvatarLoc = endLoc;
				Resolution = _res;
				vertical = _verttical;
		}

		public void SetYellow (float amt)
		{
				m1 = Color.Lerp (g1, y1, amt);
				m2 = Color.Lerp (g2, y2, amt);
		}

		public void SetOpacity (float amt)
		{
				m1 = Color.Lerp (b, g1, amt);
				m2 = Color.Lerp (b, g2, amt);

		}

		public void SetYellow (bool yellow)
		{

				if (yellow) {
						SetColors (y1, y2);
			
				} else {
						SetColors (g1, g2);
				}
		}

		public void SetWidth (float begin, float end)
		{
				beginW = begin;
				endW = end;
		}

		public void SetColors (Color b, Color e)
		{
				m1 = b;
				m2 = e;
		}
}