﻿using UnityEngine;
using System.Collections;

public class Timer : MonoBehaviour
{
		public bool activated = false;
		MovieTexture movie;
		float currentTime = 0;
		void Start ()
		{
				GetComponent<Renderer> ().enabled = false;
				movie = Resources.Load ("Timer") as MovieTexture;
				GetComponent<Renderer> ().material.SetTexture ("_MainTex", movie);

				movie.Stop ();

		}
	
		void Update ()
		{
				if (activated) {
						currentTime += Time.deltaTime;
						if (currentTime > .5f) {
								GetComponent<Renderer> ().enabled = true;
						}
				}
		}


		public void Play ()
		{

				if (!activated) {
						activated = true;
						movie.Play ();
				}
		}

		public void Pause ()
		{
				if (!activated) {
						activated = false;
						movie.Pause ();
				}
		}

		public bool IsDone ()
		{
				if (currentTime >= movie.duration) {
						return true;
				} else {
						return false;
				}
		}

		public void Stop ()
		{
				GetComponent<Renderer> ().enabled = false;
				movie.Stop ();
				currentTime = 0;
				activated = false;

		}
}
