﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class WallBehave : MonoBehaviour
{

		bool menuMode;
		int iterator = 0;
		public Renderer[] lines;

		public float pulseStep;
		public float lineWidth;
		public bool frontWall = false;
		bool pulsing = false;
		void Start ()
		{
				lines = new Renderer[transform.childCount];
				for (int i = 0; i < transform.childCount; i++) {
						lines [i] = transform.GetChild (i).GetComponent<Renderer> ();
				}

				if (frontWall) {
						for (int x =0; x < lines.Length; x++) {
								lines [x].gameObject.AddComponent<simpleRotate> ();
								lines [x].GetComponent<simpleRotate> ().SetRandom ();
								if (Random.value < .5f) {
										lines [x].GetComponent<simpleRotate> ().SetRotateSpeed (new Vector3 (0, Random.Range (.3f, .7f), 0));
								} else {
										lines [x].GetComponent<simpleRotate> ().SetRotateSpeed (new Vector3 (0, Random.Range (.3f, .7f) * -1, 0));

								}
								StartPulse (5);
						}
				}

				StartCoroutine (SteadyPulse ());

	
		}
	
		void Update ()
		{
				
		}

		public void GiveReward (int amt)
		{
				StartCoroutine (Reward (amt));
		}

		public void KillWall ()
		{
				StartCoroutine (Kill ());
		}

		public void StopPulse ()
		{
				pulsing = false;
		}

		public void StartPulse (float step)
		{
				pulseStep = step;
				pulsing = true;
				StartCoroutine (SteadyPulse ());
		}

		public void SetVisible (bool status)
		{
				foreach (Renderer line in lines) {
						line.enabled = status;
				}
		}

		public IEnumerator Kill ()
		{
				for (int i = 0; i < lines.Length; i++) {
						lines [i].enabled = false;
						yield return new WaitForSeconds (.2f);
				}
		}

		public IEnumerator SteadyPulse ()
		{
				while (pulsing) {
						StartCoroutine (SendPulse ());
						yield return new WaitForSeconds (pulseStep);
				}
		
		}

		public IEnumerator Reward (int amount)
		{
				for (int i =0; i < amount; i++) {
						StartCoroutine (SendPulse ());
						yield return new WaitForSeconds (.1f);
				}
		}

		public IEnumerator SendPulse ()
		{
				iterator = 0;
				StartCoroutine (ColorSwap (true));
				yield return new WaitForSeconds (lineWidth);
				StartCoroutine (ColorSwap (false));
		}

		public IEnumerator ColorSwap (bool yellow)
		{
				for (int i = 0; i < lines.Length; i++) {
						float step = (float)iterator / (float)lines.Length;
						if (lines [i] != null) {
								if (yellow) {
										lines [i].material.SetColor ("_Color", Color.Lerp (Color.black, Color.yellow, step));
								} else {
										lines [i].material.SetColor ("_Color", Color.black);
								}				
						}
						
						iterator ++;
						yield return new WaitForSeconds (.01f);
				}
		}
}
