﻿using UnityEngine;
using UnityEngine.Audio;
using System.Collections;
using System.Collections.Generic;
public class livePerson : MonoBehaviour
{

		GameObject player;

		public bool activated;

		string baseName;
		public List<Texture2D> texList;

		int frameIndex = 0;

		int direction = 1;
		public int frameRate = 4;

		float life = 0;
		bool dead = false;

		float globalScale = 10f;
		Vector3[] originalVerticesStorage;


		public AudioClip breakSound;

		Vector3 ogPos;
		Vector2 seed = new Vector2 (0, 0);

		public AudioMixer masterMix;

		float vocVol = 0;

		Renderer orb;
		PersonLine personLine;
		ParticleSystem particles;

		walker myWalker;
		void Start ()
		{
				frameIndex = 0;
				bool looking = true;
		
				baseName = this.name;
		
				while (looking) {
						string name;
						if (frameIndex < 10) {
								name = baseName + "/" + baseName + "_0" + frameIndex.ToString ();
						} else {
								name = baseName + "/" + baseName + "_" + frameIndex.ToString ();
						}
			
						Texture2D thisTex = Resources.Load (name) as Texture2D;
			
						if (thisTex != null) {
								texList.Add (thisTex);
								frameIndex++;
						} else {
								looking = false;
						}
				}
		
				frameIndex = 1;

				player = GameObject.Find ("player");
				myWalker = GameObject.Find ("player").GetComponent<walker> ();
				GetComponent<Renderer> ().material.SetTexture ("_MainTex", texList [0]);
				//meshDeformStuff
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
		
				originalVerticesStorage = vertices;


				ogPos = transform.position;
				seed = new Vector2 (Random.Range (0, 1000), Random.Range (0, 1000));

				orb = transform.Find ("orb").GetComponent<Renderer> ();
				orb.enabled = false;
				orb.gameObject.transform.localPosition = new Vector3 (0, -1.9f, 0);
				personLine = transform.Find ("PersonLine").gameObject.GetComponent<PersonLine> ();
				particles = transform.Find ("orb/particles").GetComponent<ParticleSystem> ();
		}
	
		void Update ()
		{
				Vector3 point = new Vector3 (player.transform.position.x, transform.position.y, player.transform.position.z);
				if (!activated) {
						transform.LookAt (point, Vector3.up);
				}
				//increment life
				if ((activated) && (!dead)) {
						life += Time.deltaTime;
				}
				//switch textures if playing
				if (activated) {
						orb.enabled = true;

						if ((orb.gameObject.transform.position.y < -1.5f) && (!dead)) {
								orb.gameObject.transform.Translate (0, .1f, 0, Space.World);
								particles.emissionRate = 0;

						} else {
								orb.gameObject.transform.localScale = Vector3.Scale (orb.gameObject.transform.localScale, new Vector3 (.998f, 1, .998f));
								particles.emissionRate += 4;
						}

						if (dead) {
								particles.emissionRate -= 10;

						}
						if (Time.frameCount % frameRate == 0) {
								if (frameIndex == 1) {
										direction = 1;
								}
			
								if (frameIndex == texList.Count - 1) {
										direction = -1;
										if (frameRate > 1) {
												frameRate--;
										}
								}
			
								if ((frameIndex < 15) && (direction == -1) && (activated)) {
										direction = 1;
								}
			
								frameIndex += direction; 
								GetComponent<Renderer> ().material.SetTexture ("_MainTex", texList [frameIndex - 1]);
						}
				}
				//raise player if close enough
				float distToPlayer = Vector3.Distance (player.transform.position, transform.position);

				if ((distToPlayer < 40) && (!dead)) {
						if (!personLine.lineActive) {
								personLine.GenerateLine ();
						}

				} 
				if (distToPlayer > 40) {
						if (personLine.lineActive) {
								personLine.DestroyLine ();
						}
				}
				if (myWalker.life < .25f) {
						if (personLine.lineActive) {
								personLine.DestroyLine ();
						}
				}



				if (distToPlayer < 20) {
//VOLUME GOES UP
						myWalker.SetSlowdown (true);
						if (vocVol < 1) {
								vocVol += .01f;
						}
						if (player.GetComponent<walker> ().life < 1) {
								if (!dead) {
										if (myWalker.life > .25f) {
												myWalker.raisingUp = true;
										}
								} else {
										
								}
						}
				} else {
						if (vocVol > 0) {
								vocVol -= .01f;
						}

				}

				if (life >= 7) {
						shatter ();
				}
				if (dead) {
						transform.Translate (0, -.13f, - .2f, Space.Self);
						distort ();

						if (transform.position.y < -20) {
								Destroy (gameObject);
						}
						//orb.enabled = false;
				}

				if (!activated) {
						float perlinScale = 10f;
						Vector2 xz = new Vector2 (Mathf.PerlinNoise (Time.time / 10, seed.x) * perlinScale, Mathf.PerlinNoise (Time.time / 10, seed.y) * perlinScale);
						Vector3 pos = transform.position;
						pos.x = ogPos.x + xz.x - (perlinScale / 2f);	
						pos.z = ogPos.z + xz.y - (perlinScale / 2f);
						//	transform.position = pos;
						
				}
				//activated = false;
		}
		float map (float s, float a1, float a2, float b1, float b2)
		{
				return b1 + (s - a1) * (b2 - b1) / (a2 - a1);
		}
		void activate ()
		{
				activated = true;

		}

		void shatter ()
		{
				dead = true;
				life = 0;
				GetComponent<Collider> ().enabled = false;
				GetComponent<AudioSource> ().clip = breakSound;
				GetComponent<AudioSource> ().loop = false;
				GetComponent<AudioSource> ().Play ();
				personLine.DestroyLine ();
				myWalker.SetSlowdown (false);
				myWalker.AddSink ();

		}

		void reset ()
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				vertices = originalVerticesStorage;
				mesh.vertices = vertices;
		
		}
	
		void OnApplicationQuit ()
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				vertices = originalVerticesStorage;
				mesh.vertices = vertices;
		
		} 
	
		void randomVerts (float localScale, int multiple)
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				//				Vector3[] normals = mesh.normals;
				int i = 0;
				while (i < vertices.Length) {
						if (i % multiple == 0) {
								vertices [i] += new Vector3 (Random.Range (-1f, 1f) * globalScale * localScale, Random.Range (-1f, 1f) * globalScale * localScale, Random.Range (-1f, 1f) * globalScale * localScale);
						}		
						i++;
				}
				mesh.vertices = vertices;
		}
	
		void distort ()
		{
				randomVerts (.0031f, 1);
		}
}
