﻿using UnityEngine;
using System.Collections;

public class musicPlayer : MonoBehaviour
{

		private AudioClip[] haHaSorry;
		private AudioClip[] ripperShading;

		public Texture2D ripperArt;
		public Texture2D ripperNormals;

		public Texture2D haHaArt;
		public Texture2D hahaNormals;

		public AudioClip[] songQueue;

		public bool on;

		int songIndex = 0;

		private float timerLength = 0;
		private AudioClip currentSong;

		private Transform beginLoc, endLoc;

		private GameObject playHead;
		AudioSource mySource;

		public TextMesh songTitle;
		public TextMesh artistName;

		public GameObject albumArt;

		Vector3 finalPos;
		//ripper shader is 5 songs
		void Start ()
		{
				mySource = GetComponent<AudioSource> ();

				ripperShading = new AudioClip [5];
				haHaSorry = new AudioClip [12];
				for (int i = 0; i < songQueue.Length; i++) {
						if (i < 5) {
								ripperShading [i] = songQueue [i];
						} else {
								haHaSorry [i % haHaSorry.Length] = songQueue [i];
						}
				}

				Reshuffle (songQueue);
				currentSong = songQueue [0];
			
				PlaySong (currentSong);
				PowerChange (false);
				timerLength = Vector3.Distance (GameObject.Find ("beginLoc").transform.position, GameObject.Find ("endLoc").transform.position);
				beginLoc = GameObject.Find ("beginLoc").transform;
				endLoc = GameObject.Find ("endLoc").transform;
				playHead = GameObject.Find ("musicPlayer_playhead");

				mySource.loop = false;

				songTitle.GetComponent<Renderer> ().material.color = Color.white;
				artistName.GetComponent<Renderer> ().material.color = Color.white;

				finalPos = transform.position;
				transform.Translate (0, -2, 0);
		}


	
		void Update ()
		{

				if (on) {
						mySource.volume = 1;
						if (transform.position != finalPos) {
								float smoothTime = 0.1F;
								float yVelocity = 0.0F;
								float newPosition = Mathf.SmoothDamp (transform.position.y, finalPos.y, ref yVelocity, smoothTime);
								transform.position = new Vector3 (transform.position.x, newPosition, transform.position.z);
				
						}
						//Vector3 tweenPos = Vector3.MoveTowards (transform.position, finalPos, Time.time / 500f);
						//transform.position = tweenPos;
						

				} else {
						mySource.volume = 0;
				}
				movePlayhead ();

				if (mySource.time >= currentSong.length) {
						NextSong ();
				}

		}

		void PlaySong (AudioClip inClip)
		{
				mySource.Stop ();
				mySource.clip = inClip;
				mySource.Play ();
				UpdateInfo ();

		}

		public void PowerChange (bool status)
		{
				on = status;

				if (on) {
						if (!mySource.isPlaying) {
								mySource.Play ();
						}
				} else {
						mySource.Pause ();
				}
		}

		public void NextSong ()
		{
				songIndex++;
				PlaySong (songQueue [songIndex % songQueue.Length]);
		}

		void UpdateInfo ()
		{
				currentSong = songQueue [songIndex % songQueue.Length];
				if (ripperCheck (currentSong)) {
						albumArt.GetComponent<Renderer> ().material.SetTexture ("_MainTex", ripperArt);
						albumArt.GetComponent<Renderer> ().material.SetTexture ("_BumpMap", ripperNormals);
						artistName.text = "nugirl//";

				} else {
						albumArt.GetComponent<Renderer> ().material.SetTexture ("_MainTex", haHaArt);
						albumArt.GetComponent<Renderer> ().material.SetTexture ("_BumpMap", hahaNormals);
						artistName.text = "wolfshirt";
				}

				songTitle.text = currentSong.name;
		}

		void movePlayhead ()
		{
				float normalizedTime = mySource.time / currentSong.length;
				playHead.transform.position = Vector3.Lerp (beginLoc.position, endLoc.position, normalizedTime);
		}

		public void PreviousSong ()
		{
				if (mySource.time / currentSong.length >= .1f) {
						mySource.time = 0;
				} else {
						songIndex--;
						if (songIndex < 0) {
								songIndex = songQueue.Length - 1;
						}
						PlaySong (songQueue [songIndex % songQueue.Length]);

				}
		}

		void Reshuffle (AudioClip[] array)
		{
				for (int i = 0; i < array.Length; i++) {
						AudioClip temp = array [i];
						int randomIndex = Random.Range (i, array.Length);
						array [i] = array [randomIndex];
						array [randomIndex] = temp;
				}
		}

		bool ripperCheck (AudioClip inAudio)
		{
				bool status = false;
				foreach (AudioClip a in ripperShading) {
						if (a == inAudio) {
								status = true;
						}
				}

				return status;
		}
}





