﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class personBehave : MonoBehaviour
{

		public string baseName;

		public List<Texture2D> texList;

		public int i = 1;

		int speed;

		public bool activated, playing;

		GameObject player;

		Vector3 floatRotation;

		public float globalScale = 10f;
		private Vector3[] originalVerticesStorage;

		float distToPlayer;
		Vector3 ogPos;
		Vector2 seed;
		bool audioPlay, dead;

		public AudioClip breakSound, angel;

		public bool starter, sidewalk;

		public int frameRate = 6;

		void Start ()
		{ 
				i = 0;
				bool looking = true;

				baseName = this.name;

				while (looking) {
						string name;
						if (i < 10) {
								name = baseName + "/" + baseName + "_0" + i.ToString ();
						} else {
								name = baseName + "/" + baseName + "_" + i.ToString ();
						}
	
						Texture2D thisTex = Resources.Load (name) as Texture2D;
			
						if (thisTex != null) {
								texList.Add (thisTex);
								i++;
						} else {
								looking = false;
						}
				}
		
				i = 1;

				player = GameObject.Find ("player");
				GetComponent<Renderer> ().material.SetTexture ("_MainTex", texList [0]);
				//meshdeform
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
		
				originalVerticesStorage = vertices;
				//perlin noise
				ogPos = transform.position;

				seed = new Vector2 (Random.Range (0, 10000), Random.Range (0, 10000));
				//audio
				audioPlay = false;

				GetComponent<AudioSource> ().clip = angel;

				//	Transform sphere = transform.GetChild (0);
				//	sphere.gameObject.GetComponent<Renderer> ().enabled = false;
		}

		void Update ()
		{
				int lifeSpan = 30;
				Vector3 point = new Vector3 (player.transform.position.x, transform.position.y, player.transform.position.z);
				distToPlayer = Vector3.Distance (player.transform.position, transform.position);
				transform.LookAt (point, Vector3.up);
				//if ((distToPlayer < 20) && (activated)) {
				if (distToPlayer < 20) {
						if (player.GetComponent<walker> ().life < 1) {
								if (globalScale < lifeSpan) {
										player.GetComponent<walker> ().raisingUp = true;
										player.GetComponent<walker> ().speed = 5;
										distortLite ();
										GetComponent<AudioSource> ().volume = 1;
								} else {
										GetComponent<AudioSource> ().volume = 0;
								}
						}
				}

				if (starter) {
						distortLite ();
						playing = true;
				}


				if (playing) {
						globalScale += (70 - distToPlayer) / 1000f;
						if (globalScale > lifeSpan) { //kill switch
								distort ();
								dead = true;
								player.GetComponent<walker> ().speed = 6;
								if (!audioPlay) {
										GetComponent<AudioSource> ().clip = breakSound;
										GetComponent<AudioSource> ().volume = 1;
										GetComponent<AudioSource> ().Play ();
										audioPlay = true;
										GetComponent<Collider> ().enabled = false;
								}

						}

						if (Time.frameCount % frameRate == 0) {
								if (i == 1) {
										speed = 1;
								}

								if (i == texList.Count - 1) {
										speed = -1;
								}

								if ((i < 15) && (speed == -1) && (activated)) {
										speed = 1;
								}

								if ((i < 2) && (!activated)) {
										playing = false;			
								}
		
								i += speed; 
								GetComponent<Renderer> ().material.SetTexture ("_MainTex", texList [i - 1]);
						}
				}
				activated = false;

				Mesh mesh = GetComponent<MeshFilter> ().mesh;

				Vector3[] vertices = mesh.vertices;
				/*
		int k = 0;
		float step =.001f;
		while (k < vertices.Length) {
			vertices [k] = Vector3.MoveTowards (vertices[k], originalVerticesStorage[k], step);
			k++;
		}
		
		*/
				mesh.vertices = vertices;

				if (!playing) {
						float perlinScale = 10f;
						Vector2 xz = new Vector2 (Mathf.PerlinNoise (Time.time / 10, seed.x) * perlinScale, Mathf.PerlinNoise (Time.time / 10, seed.y) * perlinScale);
						Vector3 pos = transform.position;
						pos.x = ogPos.x + xz.x - (perlinScale / 2f);	
						pos.z = ogPos.z + xz.y - (perlinScale / 2f);
						if (sidewalk) {
								transform.position = pos;
						}
				}

				if ((dead) && (!starter)) {
						transform.Translate (0, -.06f, 0f, Space.Self);
				}
		}
	
		void reset ()
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				vertices = originalVerticesStorage;
				mesh.vertices = vertices;
		
		}
	
		void OnApplicationQuit ()
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				vertices = originalVerticesStorage;
				mesh.vertices = vertices;
		
		} 

		void randomVerts (float localScale, int multiple)
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				//				Vector3[] normals = mesh.normals;
				int i = 0;
				while (i < vertices.Length) {
						if (i % multiple == 0) {
								vertices [i] += new Vector3 (Random.Range (-1f, 1f) * globalScale * localScale, Random.Range (-1f, 1f) * globalScale * localScale, Random.Range (-1f, 1f) * globalScale * localScale);
						}		
						i++;
				}
				mesh.vertices = vertices;
		}
	
		void distort ()
		{
				randomVerts (.0005f, 1);
		}

		void distortLite ()
		{
				randomVerts (.00004f, 1);
		}

		void activate ()
		{
				activated = true;
				playing = true;
		}
}