﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
public class starterPerson : MonoBehaviour
{
	
		GameObject player;
		public bool activated, playing;
	
		string baseName;
		public List<Texture2D> texList;
		int i = 1;
		int speed = 1;
		public int frameRate = 2;

		float globalScale = 10f;
		Vector3[] originalVerticesStorage;

		void Start ()
		{
				i = 0;
				bool looking = true;
		
				baseName = this.name;
		
				while (looking) {
						string name;
						if (i < 10) {
								name = baseName + "/" + baseName + "_0" + i.ToString ();
						} else {
								name = baseName + "/" + baseName + "_" + i.ToString ();
						}
			
						Texture2D thisTex = Resources.Load (name) as Texture2D;
			
						if (thisTex != null) {
								texList.Add (thisTex);
								i++;
						} else {
								looking = false;
						}
				}
		
				i = 1;
		
				player = GameObject.Find ("player");
				GetComponent<Renderer> ().material.SetTexture ("_MainTex", texList [0]);
				//meshDeformStuff
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
		
				originalVerticesStorage = vertices;
		
				
		}
	
		void Update ()
		{
				Vector3 point = new Vector3 (player.transform.position.x, transform.position.y, player.transform.position.z);
				transform.LookAt (point, Vector3.up);
				//switch textures if playing
				if (Time.frameCount % frameRate == 0) {
						if (i == 1) {
								speed = 1;
						}
				
						if (i == texList.Count - 1) {
								speed = -1;
						}
				
						if ((i < 15) && (speed == -1) && (activated)) {
								speed = 1;
						}
				
						if ((i < 2) && (!activated)) {
								playing = false;			
						}
				
						i += speed; 
						GetComponent<Renderer> ().material.SetTexture ("_MainTex", texList [i - 1]);
				}

				distort ();
				activated = false;
		}
	
		void activate ()
		{
		}
	

		void reset ()
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				vertices = originalVerticesStorage;
				mesh.vertices = vertices;
		
		}
	
		void OnApplicationQuit ()
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				vertices = originalVerticesStorage;
				mesh.vertices = vertices;
		
		} 
	
		void randomVerts (float localScale, int multiple)
		{
				Mesh mesh = GetComponent<MeshFilter> ().mesh;
				Vector3[] vertices = mesh.vertices;
				//				Vector3[] normals = mesh.normals;
				int i = 0;
				while (i < vertices.Length) {
						if (i % multiple == 0) {
								vertices [i] += new Vector3 (Random.Range (-1f, 1f) * globalScale * localScale, Random.Range (-1f, 1f) * globalScale * localScale, Random.Range (-1f, 1f) * globalScale * localScale);
						}		
						i++;
				}
				mesh.vertices = vertices;
		}
	
		void distort ()
		{
				randomVerts (.01f, 1);
		}
}
