﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class statusBehave : MonoBehaviour
{
		Camera cam;

		controlHub myHub;
		TextMesh myText;
		int notificationNumber = 0;
		TextMesh numberText;
		Transform anchorPos;

		List<GameObject> lines;

		public GameObject linePrefab;



		void Start ()
		{
				GameObject body = transform.Find ("statusBody").gameObject;
				body.SetActive (false);
				body.SetActive (true);

				myHub = GameObject.Find ("controlHub").GetComponent<controlHub> ();
				myText = transform.Find ("percent").GetComponent<TextMesh> ();
				numberText = transform.Find ("number").GetComponent<TextMesh> ();
				numberText.GetComponent<Renderer> ().material.color = Color.black;
				cam = GameObject.Find ("LeftEyeAnchor").GetComponent<Camera> ();
				anchorPos = transform.Find ("Anchor").transform;

				lines = new List<GameObject> ();

		}
	
		void Update ()
		{
				int percent = (int)(map (myHub.life, -0.65f, 1, 0, 1) * 100);
				myText.text = percent.ToString () + "%";

				if (Input.GetKeyDown ("q")) {
						
				}

		}
		float map (float s, float a1, float a2, float b1, float b2)
		{
				return b1 + (s - a1) * (b2 - b1) / (a2 - a1);
		}
		public void AssignAvater (Texture2D inImg)
		{
				transform.Find ("statusAvatar").gameObject.GetComponent<Renderer> ().material.mainTexture = inImg;
				transform.Find ("statusAvatar").gameObject.GetComponent<Renderer> ().material.color = Color.yellow;
		}

		public void AddNotification (Transform targetPosition)
		{

				notificationNumber ++;
				numberText.text = notificationNumber.ToString ();

				if (lines.Count > 0) {
			
						foreach (GameObject obj in lines) {
				
								if (obj.GetComponent<NoticeLine> ().AvatarLoc == targetPosition) {
										obj.GetComponent<NoticeLine> ().SetYellow (true);
								}
						}
				}
		}

		public void RemoveNotification (Transform targetPosition)
		{
				if (notificationNumber > 0) {
						notificationNumber --;
				}
				numberText.text = notificationNumber.ToString ();

				if (lines.Count > 0) {
			
						foreach (GameObject obj in lines) {
				
								if (obj.GetComponent<NoticeLine> ().AvatarLoc == targetPosition) {
										obj.GetComponent<NoticeLine> ().SetYellow (false);
								}
						}
				}
				
		}

		public void AddConnection (Transform targetPosition)
		{
				GameObject thisObj = new GameObject ("NoticeLine");
				thisObj.AddComponent <NoticeLine> ();
				thisObj.GetComponent<NoticeLine> ().SetLine (anchorPos, targetPosition, 50, true);
				thisObj.GetComponent<NoticeLine> ().SetWidth (.4f, .05f);
				thisObj.GetComponent<NoticeLine> ().SetYellow (false);

				lines.Add (thisObj);
		}

		public void RemoveConnection (Transform targetPosition)
		{
				if (lines.Count > 0) {
			
						foreach (GameObject obj in lines) {
				
								if (obj.GetComponent<NoticeLine> ().AvatarLoc == targetPosition) {
										lines.Remove (obj);
										Destroy (obj);
										break;
								}
						}
				}
		}

		
}
